--- old/usr/src/cmd/sgs/libld/common/unwind.c	2012-10-11 22:38:19.457202684 -0400
+++ new/usr/src/cmd/sgs/libld/common/unwind.c	2012-10-11 22:38:19.469780013 -0400
@@ -639,8 +639,8 @@
 					    (void) dwarf_ehe_extract(
 						&data[off + ndx],
 						&ndx, ciePflag,
-						ofl->ofl_dehdr->e_ident,
-						shdr->sh_addr, off + ndx);
+						ofl->ofl_dehdr->e_ident, B_FALSE,
+						shdr->sh_addr, off + ndx, 0);
 					    break;
 					case 'R':
 					    /* code encoding */
@@ -658,10 +658,17 @@
 				uint_t	    bintabndx;
 				uint64_t    initloc;
 				uint64_t    fdeaddr;
+				uint64_t    gotaddr = 0;
+
+				if (ofl->ofl_osgot != NULL)
+					gotaddr =
+					    ofl->ofl_osgot->os_shdr->sh_addr;
 
 				initloc = dwarf_ehe_extract(&data[off],
 				    &ndx, cieRflag, ofl->ofl_dehdr->e_ident,
-				    shdr->sh_addr, off + ndx);
+				    B_FALSE,
+				    shdr->sh_addr, off + ndx,
+				    gotaddr);
 
 				/*
 				 * Ignore FDEs with initloc set to 0.
